package de.ivu.elect.business.protokollierung.control;

import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicLong;

import javax.ejb.DependsOn;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.inject.Inject;

import de.ivu.elect.business.system.control.AbstractElectBackgroundService;
import de.ivu.elect.business.system.entity.SystemLogQuelle;

@Startup
@Singleton
@DependsOn("DbInit")
//https://issues.jboss.org/browse/EJBTHREE-2070 (keine Transaktion)
@TransactionManagement(TransactionManagementType.BEAN)
public class ProtokollBereinigungBackgroundService extends AbstractElectBackgroundService {

  public static final AtomicLong RUNNING = createRunning();

  public static final AtomicBoolean DISABLED = createDisabled();

  @Inject
  private transient ProtokollBereinigung protokollBereinigung;

  @Override
  protected AtomicBoolean getDisabledInternal() {
    return DISABLED;
  }

  @Override
  protected boolean isSomethingToDoInternal() {
    // ProtokollBereinigung kann nicht bestimmen, ob etwas zu tun ist => wenn gestartet einmal laufen
    return getRunning().get() > RUNNING_INITIAL;
  }

  @Override
  protected void doSomethingInternal() {
    try {
      protokollBereinigung.bereinigeProtokolleintraege();
    } finally {
      // nicht als Vorlage für weitere Background-Jobs verwenden(!)
      // ProtokollBereinigung kann nicht bestimmen, ob etwas zu tun ist => wenn gestartet einmal laufen
      getRunning().decrementAndGet();
    }
  }

  @Override
  public SystemLogQuelle getSystemLogQuelle() {
    return SystemLogQuelle.PROTOKOLL_CLEANUP;
  }

  @Override
  protected AtomicLong getRunning() {
    return RUNNING;
  }

}

